#include "cheat.h"

/*****************************************************************************

    Function: pokebyte

    Description: set a value in the ram to a specified value
    Parameters: none
    Return: 0

*****************************************************************************/

char pokebyte()
{
    char tmp_str[10],new_val,index=0;
    unsigned addr;

      while (keypressed()) readkey(); // Flushing keys
      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;
      addr=atoi(tmp_str);

      while (keypressed()) readkey(); // Flushing keys
      index=0;
      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;
      new_val=atoi(tmp_str);

      RAM[addr]=new_val;

      {
       char* tmp_buf=(char*)alloca(100);
       sprintf(tmp_buf,"BYTE AT %d SET TO %d",addr,new_val);
       set_message(tmp_buf);
       message_delay=180;
       }


      return 0;
 }

/*****************************************************************************

    Function: searchbyte

    Description: search the ram for a particuliar value
    Parameters: none
    Return: 1 on error

*****************************************************************************/

char searchbyte()
{
    char tmp_str[10];
    unsigned short index=0,tmp_word,last_index;
    char data_filename[80],old_filename[80];
    char first_research=1;
    FILE *D,*O;
    unsigned char to_search;
      while (keypressed()) readkey(); // Flushing keys

      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;

      to_search=atoi(tmp_str);

      strcpy(old_filename,short_cart_name);
      strcpy(data_filename,short_cart_name);
      strcat(data_filename,"FP1");

      if (exists((char*)strcat(old_filename,"FP0")))
       {
	     if (!(O=fopen(old_filename,"rb")))
	       return 1;
	     first_research=0;
       }

      if (!(D=fopen(data_filename,"wb")))
	     return 1;
      //textout(screen,font,"Testing!",blit_x,blit_y,-1);
      tmp_str[9]=0;
      for (index=0;index<0x8000;index++)
	 {
//          textout(screen,font,itoa(index,tmp_str,10),0,10,1);
	  if ((unsigned char)RAM[index]==to_search)
	    {

	     if	(first_research)
		    fwrite(&index,2,1,D);
	     else
		  {
		 //fseek(O,0,SEEK_SET);
		   while (!(feof(O)))
		    {
		     fread(&tmp_word,2,1,O);
		     if	(tmp_word>=index)
		       {
			      fseek(O,-2,SEEK_CUR);
			      break;
		       }
		   }

		 if (index==tmp_word)
		   {
		     fwrite(&index,2,1,D);
           last_index=index;
		     //textout(screen,font,itoa(index,tmp_str,10),blit_x,blit_y+(tmp_str[9]+=8,tmp_str[9]%=200),-1);
		   }
		 }//search for old occurences
	   }
	  }

      if (!first_research)
	     fclose(O);
      fclose(D);

      rename(data_filename,old_filename);
      if (!file_size(old_filename))
	     {
          //textout(screen,font,"Search failed",0,0,-1);
          set_message("SEARCH FAILED");
          message_delay=180;
	       unlink(old_filename);
	       //readkey();
	       return 1;
        }

      if (file_size(old_filename)==2)
        {
         char* tmp_buf=(char*)alloca(100);
         sprintf(tmp_buf,"FOUND AT %d",last_index);
         set_message(tmp_buf);
         message_delay=60*5;
         }
      else
        {
         set_message("STILL NEED TO SEARCH");
         message_delay=180;
         }
      //textout(screen,font,itoa(file_size(old_filename)/2,tmp_str,10),0,0,1);
      //readkey();
      return 0;

    }

/*****************************************************************************

    Function: loadgame

    Description: load a saved game using allegro packing functions
    Parameters: none
    Return: 1 on error, else 0

*****************************************************************************/

char loadgame()
  {
   	PACKFILE *fp;
	char tmp=0;
   //,final[80];

//        while ((cart_name[0]) && (final[tmp]=cart_name[tmp++])!='.');
//        final[tmp]=0;
//	strcpy(final,short_cart_name);
//	strcat(final,"SAV");
   //sprintf(final,"%s%s.SAV",sav_path,short_cart_name);

	if (!(fp=pack_fopen(sav_path,F_READ_PACKED)))
	  return 1;
	pack_fread(RAM, 0x8000, fp);
	pack_fread(VRAM, VRAMSIZE, fp);
	pack_fread(SPRAM,	64*4*sizeof(short), fp);
	pack_fread(Pal, 512, fp);
	pack_fread(&scanline, sizeof(int), fp);
	pack_fread(&io, sizeof(IO), fp);
	pack_fread(&M, sizeof(M6502), fp);

	if (populus)
		pack_fread(PopRAM, PopRAMsize, fp);
	for (tmp = 0; tmp < 8; tmp++)
		bank_set(tmp, M.MPR[tmp]);
	memset(vchange , 1, VRAMSIZE/32 );
	memset(vchanges, 1, VRAMSIZE/128);

	pack_fclose(fp);
   return 0;
   }

/*****************************************************************************

    Function: savegame

    Description: save a game using allegro packing functions
    Parameters: none
    Return: 1 on error, else 0

*****************************************************************************/


char savegame()
  {
   PACKFILE	*fp;
   //,final[80];

//        while ((cart_name[0]) && (final[tmp]=cart_name[tmp++])!='.');
//        final[tmp]=0;

  // sprintf(final,"%s%s.SAV",sav_path,short_cart_name);

//	strcpy(final,short_cart_name);
//	strcat(final,"SAV");
	if (!(fp=pack_fopen(sav_path,F_WRITE_PACKED)))
	  return 1;

   pack_fwrite(RAM, 0x8000, fp);
	pack_fwrite(VRAM, VRAMSIZE, fp);
	pack_fwrite(SPRAM, 64*4*sizeof(short), fp);
	pack_fwrite(Pal, 512, fp);
	pack_fwrite(&scanline, sizeof(int), fp);
	pack_fwrite(&io, sizeof(IO), fp);
	pack_fwrite(&M, sizeof(M6502), fp);
	if (populus)
		pack_fwrite(PopRAM, PopRAMsize, fp);
	return pack_fclose(fp);
   }

