#include "mix.h"
#define DWORD unsigned int
#define WORD unsigned short int

int mseq(DWORD *rand_val)
{
	if (*rand_val & 0x00080000)
	{
		*rand_val = ((*rand_val ^ 0x0004) << 1) + 1;
		return 1;
	}
	else
	{
		*rand_val <<= 1;
		return 0;
	}
};
END_OF_FUNCTION(mseq);


void WriteBuffer(char *buf, int ch, unsigned  dwSize)
{
//#ifdef _DEBUG
//	if (ch == 0)
//		debug_dump("%08X-%08X\n", buf-sbuf[ch], buf-sbuf[ch]+dwSize);
//#endif


	static DWORD	n[6] = {0,0,0,0,0,0};
// represent the current pointer in the ring buffer of the given chanel


#define	N	32
	static DWORD	k[6] = {0,0,0,0,0,0};

	static DWORD	t;
// used to know how much we got to advance in the ring buffer

//	static BOOL		bInit = TRUE;
	static DWORD	r[6];


	static DWORD	rand_val[6] = {0,0,0,0,0x51F631E4,0x51F631E4};
// random seed for 'noise' generation

   WORD	wave[32];


	// a*2^(b*x)
	// a = 400, b = log2(16384/a), x = 0.0 ~ 1.0
//	static int		vol_tbl[32] =
//	{
//		100,451,508,573,646,728,821,925,
//		1043,1175,1325,1493,1683,1898,2139,2411,
//		2718,3064,3454,3893,4388,4947,5576,6285,
//		7085,7986,9002,10148,11439,12894,14535,16384,
//	};

	static char		vol_tbl[32] =
	{
		100/256,451/256,508/256,573/256,646/256,728/256,821/256,925/256,
		1043/256,1175/256,1325/256,1493/256,1683/256,1898/256,2139/256,2411/256,
		2718/256,3064/256,3454/256,3893/256,4388/256,4947/256,5576/256,6285/256,
		7085/256,7986/256,9002/256,10148/256,11439/256,12894/256,14535/256,16384/256
	};


	DWORD	dwPos;
	int	lvol, rvol,i;
	DWORD	Tp;
	//unsigned	dum=0;

	if (!(io.PSG[ch][4]&0x80))
	{
	   // voice off
		n[ch] = k[ch] = 0;
		for (dwPos = 0; dwPos < dwSize; dwPos++)
			*buf++ = 0;
      //memset(buf,0,dwSize);
		//memset(sbuf[ch],0,dwSize);
		return;
	}

//	TRACE("buf=%08X,size=%08X\n", buf, dwSize);

	if ((io.PSG[ch][4]&0x40) /*&& (ch!=5)*/)
	{
//		fprintf(stderr,"wave=%d\n", io.wave[ch][0]);
		wave[0] = ((signed char)io.wave[ch][0]-16);
//		if (ds_nChannels == 2)
//		{
//			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
//			lvol = lvol-60;
//			if (lvol < 0) lvol = 0;
//			lvol = (int)(short)wave[0]*vol_tbl[lvol]/16384;
//			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
//			rvol = rvol-60;
//			if (rvol < 0) rvol = 0;
//			rvol = (int)(short)wave[0]*vol_tbl[rvol]/16384;
//			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
//			{
//				*buf++ = (WORD)lvol;
//				*buf++ = (WORD)rvol;
//			}
//		}
//		else
		{
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = (signed char)wave[0]*vol_tbl[lvol]/64/256;
			//lvol = (((io.psg_volume>>4)&0x0F) + ((io.psg_volume)&0x0F))
			//	  + (io.PSG[ch][4]&0x1F)
			//	  + (((io.PSG[ch][5]>>4)&0x0F) + ((io.PSG[ch][5])&0x0F));
			// lvol = [| 0..95 |]

			//lvol = (wave[0] * lvol) / 48;
			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{
				*buf++ = (WORD)lvol;
			}
			//memset(buf,lvol,dwSize);
			//memset(sbuf[ch],lvol,dwSize);
		}
	}
	else
	{
//for (dwPos = 0; dwPos < dwSize; dwPos++)
//	*buf++ = 0;
//return;
		if (ch >= 4 && (io.PSG[ch][7]&0x80)) //Noise
		{
			DWORD Np = (io.PSG[ch][7]&0x1F); //Noise 'frequency'
//			if (ds_nChannels == 2) // STEREO DISABLED
//			{
//				lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
//				lvol = lvol-60;
//				if (lvol < 0) lvol = 0;
//				lvol = vol_tbl[lvol];
//				rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
//				rvol = rvol-60;
//				if (rvol < 0) rvol = 0;
//				rvol = vol_tbl[rvol];
//				for (dwPos = 0; dwPos < dwSize; dwPos += 2)
//				{
//					k[ch] += 3000+Np*512;
//					t = k[ch] / (DWORD)freq_int;
//					if (t >= 1)
//					{
//						r[ch] = mseq(&rand_val[ch]);
//						k[ch] -= freq_int*t;
//					}
//					*buf++ = (WORD)((r[ch] ? 10*702 : -10*702)*lvol/64);
//					*buf++ = (WORD)((r[ch] ? 10*702 : -10*702)*rvol/64);
//				}
//			}
//			else  // MONO
			{
				lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
							max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
            //average sound level

				lvol = lvol-60;

				if (lvol < 0) lvol = 0;
				lvol = vol_tbl[lvol];
				// get cooked volume

			//lvol = (((io.psg_volume>>4)&0x0F) + ((io.psg_volume)&0x0F))
			//	  + (io.PSG[ch][4]&0x1F)
			//	  + (((io.PSG[ch][5]>>4)&0x0F) + ((io.PSG[ch][5])&0x0F));
			// lvol = [| 0..95 |]

			//lvol = (wave[0] * lvol) / 12;


				for (dwPos = 0; dwPos < dwSize; dwPos++)
				{
 				   k[ch] += 3000+Np*512;

					t = k[ch] / (DWORD)freq_int;

					if (t >= 1)
					{
						r[ch] = mseq(&rand_val[ch]);
						k[ch] -= freq_int*t;
					}
					*buf++ = (WORD)((r[ch] ? 10*702 : -10*702)*lvol/64/256);
					//sbuf[ch][dum++] = (WORD)((r[ch] ? 10*702 : -10*702)*lvol/64/256);
					//*buf++ = (r[ch] ? 32 : -32) * lvol / 24;
				}
			}
			return;
		} // END NOISE

		for (i = 0; i < 32; i++)
			wave[i] = (io.wave[ch][i]-16)*3;
		// load the data in IO


		Tp = io.PSG[ch][2]+((DWORD)io.PSG[ch][3]<<8);
                  // Tp = frequency

		if (Tp == 0)
		{  // NO SOUND
			for (dwPos = 0; dwPos < dwSize; dwPos++)
				*buf++ = 0;
			//memset(buf,0,dwSize);
			//memset(buf,0,dwSize);
			return;
		}

//		if (ds_nChannels == 2)  //STEREO TOTALLY DISABLED
//		{
//			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
//			lvol = lvol-60;
//			if (lvol < 0) lvol = 0;
//			lvol = vol_tbl[lvol];
//			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
//			rvol = rvol-60;
//			if (rvol < 0) rvol = 0;
//			rvol = vol_tbl[rvol];
//			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
//			{
//				*buf++ = (WORD)((int)(short)wave[n[ch]]*lvol/64);
//				*buf++ = (WORD)((int)(short)wave[n[ch]]*rvol/64);
//				k[ch] += N*1118608/Tp;
//				t = k[ch] / (10*(DWORD)freq_int);
//				n[ch] = (n[ch]+t)%N;
//				k[ch] -= 10*freq_int*t;
//			}
//		}
//		else
		{  // MONO
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			//fprintf(stderr,"%d\n",lvol);
			if (lvol < 0) lvol = 0;
			lvol = vol_tbl[lvol];
			// get cooked volume

//			lvol = (((io.psg_volume>>4)&0x0F) + ((io.psg_volume)&0x0F))
//				  + (io.PSG[ch][4]&0x1F)
//				  + (((io.PSG[ch][5]>>4)&0x0F) + ((io.PSG[ch][5])&0x0F));
			// lvol = [| 0..95 |]

//			lvol = (wave[0] * lvol) / 12;


			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{  // fill the buffer
				*buf++ = (char)(wave[n[ch]]*lvol/16);
				//sbuf[ch][dwPos] = wave[n[ch]]*lvol/16;
				//*buf++ = wave[n[ch]]*lvol/48;


				//if (ch==1)
				  //fwrite(buf-1,1,1,out_snd);
				  //fprintf(stderr,"Je viens d'crire %d en 1\n",*(buf-1));
				  //fprintf(stderr,"sbuf[1] = %p\n",sbuf[1]);

				k[ch] += N*1118608/Tp;

				t = k[ch] / (10*(DWORD)freq_int);
				// the value to advance in the ring buffer

				n[ch] = (n[ch]+t)%N;
				// advancing the pointer

				k[ch] -= 10*freq_int*t;
//				*buf++ = (char)(wave[fixtoi(snd_pos[ch])]*lvol/16);
//				//sbuf[ch][dum++] = (char)(wave[fixtoi(snd_pos[ch])]*lvol/16);
//
//		      snd_pos[ch]+=snd_inc[ch];
//            snd_pos[ch]&=31*65535+65536;

			}
		}
	}
};

END_OF_FUNCTION(WriteBuffer);


